--
-- GMTracks
--
--
-- @author jodamm
-- @date 19/04/2017
--

GMTracks = {};
function GMTracks.prerequisitesPresent(specializations)
    return true;
end

function GMTracks:load(savegame)
end

function GMTracks:delete()
end

function GMTracks:mouseEvent(posX, posY, isDown, isUp, button)
end

function GMTracks:keyEvent(unicode, sym, modifier, isDown)
end

function GMTracks:update(dt)
    --Change terrainDetail back to default
    if GroundModification.terrDetailOk then
        g_currentMission.terrainDetailId = GroundModification.terrainDetailId;
    end
end

function GMTracks:draw()
end

function GMTracks.prepTrackUpdate(ikChains)
    --change terrainDetail to capture trackcolor
    if GroundModification.terrDetailOk and GMTracks.vehicleUpdate then
        g_currentMission.terrainDetailId = GroundModification.terrDetail;
    end
end

function GMTracks.prepVehicleUpdate(self, dt)
    GMTracks.vehicleUpdate = true;
end

function GMTracks.appVehicleUpdate(self, dt)
    GMTracks.vehicleUpdate = false;
end

function GMTracks.getTireTrackColorFromDensityBits(densityBits, superFunc)
    if g_currentMission.terrainDetailId == GroundModification.terrainDetailId then
        return superFunc(densityBits);
    end

    if densityBits > 64 then
        densityBits = bitAND(densityBits, 63);
    end
    local color = {0.138, 0.082, 0.045, 1};
    local sound = GroundModification.fieldSound;
    if densityBits == 5 or densityBits == 10 or densityBits == 17 or densityBits == 18  then
        sound = g_currentMission.surfaceNameToSurfaceSound.grass;
        color = {0.208, 0.11, 0.056, 1};
    elseif densityBits == 6 or densityBits == 8 then
        sound = g_currentMission.surfaceNameToSurfaceSound.asphalt;            
        color = {0.4, 0.4, 0.4, 0};
    elseif densityBits == 7 then
        sound = g_currentMission.surfaceNameToSurfaceSound.grass;            
        color = {0.901, 0.613, 0.365, 1};
    elseif densityBits == 9 or densityBits == 12 then
        sound = g_currentMission.surfaceNameToSurfaceSound.leaves;                    
    elseif densityBits == 11 then --gravel
        sound = g_currentMission.surfaceNameToSurfaceSound.dirt;            
        color = {0.5, 0.5, 0.5, 1};
    elseif densityBits == 13 then
        sound = g_currentMission.surfaceNameToSurfaceSound.asphalt;            
        color = {0.167, 0.163, 0.159, 0};
    elseif densityBits == 14 or densityBits == 16 then
        sound = g_currentMission.surfaceNameToSurfaceSound.dirt;            
        color = {0.155, 0.082, 0.037, 1};
    elseif densityBits == 15 then
        sound = g_currentMission.surfaceNameToSurfaceSound.asphalt;            
        color = {0.138, 0.082, 0.045, 0};
    end
    if g_currentMission.surfaceNameToSurfaceSound ~= nil then
        g_currentMission.surfaceNameToSurfaceSound.field = sound;            
    end    
    return unpack(color);
end


IKUtil.updateIKChains = Utils.appendedFunction(IKUtil.updateIKChains, GMTracks.prepTrackUpdate);
Vehicle.update = Utils.prependedFunction(Vehicle.update, GMTracks.prepVehicleUpdate);
Vehicle.update = Utils.appendedFunction(Vehicle.update, GMTracks.appVehicleUpdate);
Utils.getTireTrackColorFromDensityBits = Utils.overwrittenFunction(Utils.getTireTrackColorFromDensityBits, GMTracks.getTireTrackColorFromDensityBits);
